ACCEPT continue CHAR PROMPT 'Set a numeric event on session level' HIDE
alter session set events '10046 trace name context forever, level 12';

ACCEPT continue CHAR PROMPT 'Set a numeric event on system level' HIDE
alter system set events '00001 trace name errorstack level 3, forever';

ACCEPT continue CHAR PROMPT 'Set an Event++ on session level' HIDE
alter session set events 'sql_trace[SQL: dqpug8ysxy4rp] wait=true,bind=true,plan_stat=all_executions';

ACCEPT continue CHAR PROMPT 'Set an UTS trace event on system level' HIDE
alter system set events 'trace[RDBMS.SQL_Optimizer.*][SQL: dqpug8ysxy4rp] disk=high';
oradebug doc component SQL_Optimizer

ACCEPT continue CHAR PROMPT 'List events with help of dbms_system.read_ev() in my own session' HIDE
set serveroutput on;
declare
    event_level   number;
begin
    for i in 0..65535 loop
        dbms_system.read_ev(i,event_level);
        if
            ( event_level > 0 )
        then
            dbms_output.put_line('Event '
                                   || to_char(i)
                                   || ' set at level '
                                   || to_char(event_level) );
        end if;
    end loop;
end;
/

ACCEPT continue CHAR PROMPT 'List events with help of ORADEBUG' HIDE
oradebug setmypid
oradebug eventdump system
oradebug eventdump session

ACCEPT continue CHAR PROMPT 'Disable all set events from above' HIDE
alter session set events '10046 trace name context off';
alter system set events '00001 trace name context off';
alter session set events 'sql_trace[SQL: dqpug8ysxy4rp] off';
alter system set events 'trace[RDBMS.SQL_Optimizer.*][SQL: dqpug8ysxy4rp] off';

ACCEPT continue CHAR PROMPT 'List events with help of ORADEBUG' HIDE
oradebug setmypid
oradebug eventdump system
oradebug eventdump session
