drop user test cascade;
create user test identified by test default tablespace users;
grant dba to test;
grant sysdba to test;

connect test/test@T183DB
col value format a80
select value from v$diag_info where name = 'Default Trace File';

@/Users/istefan/SQLs/10_talks/DOAG2018_181120/demo_deploy_ora00600_object.sql
create table t1 as select rownum as uniqueid, a.* from dba_objects a where rownum < 21;
create unique index t1_i on t1(uniqueid);
exec dbms_stats.gather_table_stats(USER,'T1');

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Set an event on ORA-00001 to dump an ERRORSTACK trace' HIDE
alter session set events '00001 trace name errorstack level 3, forever';

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect test/test@T183DB
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Set an event on ORA-00001 to dump an ERRORSTACK trace but kick in only 2 times' HIDE
alter session set events '00001 trace name errorstack level 3, lifetime 2';

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'List all available actions' HIDE
connect sys/manager@T183DB as sysdba
oradebug dumplist

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect test/test@T183DB
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Set an event on ORA-00001 with multiple actions' HIDE
alter session set events '00001 trace name errorstack level 3, lifetime 1 ; name callstack lifetime 2';

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Run DML to hit Oracle error ORA-00001' HIDE
insert into t1(uniqueid) values (1);

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect test/test@T183DB
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Geeky 0x/Hex version of setting a numeric event (SQL Trace - 10046 with level 12)' HIDE
alter session set events '0x273E trace name context forever, level 0xC';
select 1 from dual;
