ACCEPT continue CHAR PROMPT 'ORADEBUG DOC EVENT NAME TRACE' HIDE
oradebug doc event name trace

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC COMPONENT' HIDE
oradebug doc component

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC COMPONENT SQL_COMPILER' HIDE
oradebug doc component SQL_Compiler

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T183DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Enable UTS trace for the SQL compiler and its sub-components for specific SQL-ID only' HIDE
alter session set events 'trace[RDBMS.SQL_Compiler.*][SQL: 869cv4hgb868z] disk=highest';

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
select count(*) from test.t1 where uniqueid < 5;

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T183DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Enable UTS trace (memory) for the SQL compiler and its sub-components for specific SQL-ID only' HIDE
alter session set events 'trace[RDBMS.SQL_Compiler.*][SQL: 869cv4hgb868z] disk=disable,memory=highest';

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
select count(*) from test.t1 where uniqueid < 5;

ACCEPT continue CHAR PROMPT 'Query X$TRACE for generated trace information' HIDE
column DATA format A100
select component, function, data from x$trace where sid in (select sid from v$mystat where rownum = 1) order by time;

ACCEPT continue CHAR PROMPT 'How to control circular memory buffer (X$TRACE) and where it is stored' HIDE
column NAME format A55
column VALUE_U format A50
column DESCRIPTION format A100
select x.ksppinm NAME, y.ksppstvl VALUE_U, ksppdesc DESCRIPTION from x$ksppi x, x$ksppcv y where x.indx = y.indx and x.ksppinm like '_trace%' order by x.ksppinm;
select * from v$sgastat where name = 'trace events array';

ACCEPT continue CHAR PROMPT 'Run query that results in ORA-00600 error' HIDE
select value from v$diag_info where name = 'Default Trace File';
@/Users/istefan/SQLs/10_talks/DOAG2018_181120/demo_run_ora00600.sql

--ACCEPT continue CHAR PROMPT 'Dump circular memory buffer (X$TRACE) manually' HIDE
--select value from v$diag_info where name = 'Default Trace File';
--oradebug setmypid
--oradebug dump kstdumpcurproc 1

--ACCEPT continue CHAR PROMPT 'Dump an error stack trace manually with help of ORADEBUG (broken - no KST trace buckets)' HIDE
--select value from v$diag_info where name = 'Default Trace File';
--oradebug setmypid
--oradebug dump errorstack 3
